//
//  ObjCSample.h
//  LanguagesDemo
//
//  Created by Tim Triemstra on 8/21/11.
//  Copyright (c) 2011 Apple, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>


/** This is a smaple of how to use the header file to expose only API.  This will hide all the ivars and any other encapsulated information that consumers of the API don't need to see.  This requires ARC, and the "new" runtime introduced with iOS and 64-bit Objective-C on the Mac.
*/
@interface ObjCClass : NSObject

    @property (strong) NSNumber    *publicNumberProperty;
    
    + (void) doSomething;
    
@end

/** And a subclass to see how well things like the private ivars work, or even private @properties
*/
@interface ObjCDerived : ObjCClass {}

    + (void) testDerived;

@end



/** This class is a sample showing how to work with ivars in an @interface block
*/
@interface PersonOBJC : NSObject {

    NSInteger   defaultInt;     // just use the default. should be @protected

    @private
    NSInteger   privateInt;     // @private is the default in code completion. why?
    
    @protected
    NSInteger   protectedInt;   
    
    @public
    NSInteger   publicInt;      // yes, this is bad practice, just used for this demo.
}
@end
