//
//  ObjCSample.m
//  LanguagesDemo
//
//  Created by Tim Triemstra on 8/21/11.
//  Copyright (c) 2011 Apple, Inc. All rights reserved.
//

#import "ObjCSample.h"


/** This is a class extension, adding some extra @properties that only this class can use
*/
@interface ObjCClass()
    @property (strong) NSString     *prvtStr;   // How do private properties work?
    
    + (void) doSomethingPrivate;
    
@end

@implementation ObjCClass {
    NSString    *privateString;
    NSInteger   someNumber;
}

// MARK:  -----------------------------------------  Implementation of all methods

+ (void) doSomething
{
    ;
}

+ (void) doSomethingPrivate
{
    ;
}


// synthesize cleanup *sigh* - can't wait for synthesize by default!
@synthesize publicNumberProperty;
@synthesize prvtStr;

@end


/** This is just testing what elements of the base class, ObjCClass, that the derived class can access.  Trying to understand if protected @properties or ivars declared in the .m file are also hidden from derived classes, or only hidden as part of the public API.
*/
@implementation ObjCDerived
        
+ (void) testDerived
{
    ;
}


@end